<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ContainerDialog xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ContainerDialog.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.ui.dialogs;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ArrayContentProvider;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.CheckStateChangedEvent;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.CheckboxTableViewer;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ICheckStateListener;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelectionChangedListener;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.SelectionChangedEvent;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.StructuredSelection;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.ContainerRule;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.RuleApplication;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.component.ContainerUtil;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.DescriptionUtils;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.toolbox.utils.DialogUtils;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.layout.GridData;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.layout.GridLayout;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Control;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Group;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Text;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.dialogs.SelectionStatusDialog;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment"> * Select container rules, either from a list of globally defined rules</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment"> * or from local rules which may be created "on the fly" by this dialog.</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment"> * TODO: extend rule application to instances (problematic, since rules transformation</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment"> * is done on type level)</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ContainerDialog.html">ContainerDialog</a> <strong class="jxr_keyword">extends</strong> SelectionStatusDialog {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<strong class="jxr_keyword">protected</strong> Class m_component;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<em class="jxr_comment">// protected EList&lt;Package&gt; visitedPackages;</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">protected</strong> Text fDescription;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<em class="jxr_comment">// protected FilteredList fRules;</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  	<strong class="jxr_keyword">protected</strong> CheckboxTableViewer fRules;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<em class="jxr_comment">// protected Combo fInterceptionKind;</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<em class="jxr_comment">// protected Button fInterButton;</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<em class="jxr_comment">// protected Label fPortLabel;</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<em class="jxr_comment">// protected Text fRuleName;</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  	<em class="jxr_comment">// protected Button fOptionButton;</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  	<em class="jxr_comment">// protected Button fPortButton;</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<strong class="jxr_keyword">protected</strong> ContainerRule m_currentRule;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<strong class="jxr_keyword">protected</strong> Package m_model;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> m_rulePropertiesOnly;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ContainerDialog.html">ContainerDialog</a>(Shell parent, Class componentOrRule) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		<strong class="jxr_keyword">super</strong>(parent);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		<em class="jxr_comment">// visitedPackages = new BasicEList&lt;Package&gt; ();</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		m_rulePropertiesOnly = StereotypeUtil.isApplied(componentOrRule, ContainerRule.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<strong class="jxr_keyword">if</strong> (m_rulePropertiesOnly) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			<em class="jxr_comment">// m_currentRule = UMLUtil.getStereotypeApplication(componentOrRule, ContainerRule.class);</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			m_component = componentOrRule;
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		m_model = PackageUtil.getRootPackage(componentOrRule);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 * @see SelectionStatusDialog#computeResult()</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  	@Override
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> computeResult() {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		<em class="jxr_comment">// nothing to do</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	@Override
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 	<strong class="jxr_keyword">public</strong> Control createDialogArea(Composite parent) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		Composite contents = (Composite) <strong class="jxr_keyword">super</strong>.createDialogArea(parent);
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<em class="jxr_comment">// (parent, "Container rules", "Avail. extensions/interceptors");</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">if</strong> (m_rulePropertiesOnly) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			createRuleInfoGroup(contents);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			selectRule(m_currentRule);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			createRuleSelectionGroup(contents);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			createRuleInfoGroup(contents);
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<strong class="jxr_keyword">return</strong> contents;
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 	}
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createRuleSelectionGroup(Composite parent) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		Composite ruleSelections = <strong class="jxr_keyword">new</strong> Composite(parent, SWT.NONE);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		GridLayout grid = <strong class="jxr_keyword">new</strong> GridLayout(1, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		GridData groupGridData = <strong class="jxr_keyword">new</strong> GridData();
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<em class="jxr_comment">// data3.widthHint = 400;</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		<em class="jxr_comment">// data3.heightHint = 300;</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		groupGridData.grabExcessVerticalSpace = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		groupGridData.grabExcessHorizontalSpace = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		groupGridData.horizontalAlignment = GridData.FILL;
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		groupGridData.verticalAlignment = GridData.FILL;
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		ruleSelections.setLayout(grid);
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		ruleSelections.setLayoutData(groupGridData);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		ruleSelections.setSize(400, 300);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_comment">		 * fRules = DialogUtils.createFilteredList (ruleSelGroup, new RuleLabelProvider(), 200, 200,</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> <em class="jxr_comment">		 * SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL);</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		GridData data = <strong class="jxr_keyword">new</strong> GridData(GridData.FILL_BOTH);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		data.heightHint = 150;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		data.widthHint = 200;
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		ICheckStateListener checkListener = <strong class="jxr_keyword">new</strong> ICheckStateListener() {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			@Override
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> checkStateChanged(CheckStateChangedEvent event) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 				Object obj = event.getElement();
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 				<strong class="jxr_keyword">if</strong> (obj instanceof ContainerRule) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 					ContainerRule rule = (ContainerRule) obj;
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 					<strong class="jxr_keyword">if</strong> (event.getChecked()) {
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 						applyRule(rule);
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 					}
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 					<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 						unapplyRule(rule);
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 					}
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 				}
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 			}
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		};
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		<em class="jxr_comment">// --------------- global rules -------------------</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		Group gRuleSelGroup = <strong class="jxr_keyword">new</strong> Group(ruleSelections, SWT.BORDER);
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		gRuleSelGroup.setText(<span class="jxr_string">" available rules "</span>);
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		<em class="jxr_comment">// ruleGroup.setLayout(new RowLayout (SWT.VERTICAL));</em>
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		gRuleSelGroup.setLayout(<strong class="jxr_keyword">new</strong> GridLayout(1, false));
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		gRuleSelGroup.setLayoutData(groupGridData);
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 		EList&lt;ContainerRule&gt; globalRuleList = ContainerUtil.getAllRules(m_model);
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		<em class="jxr_comment">// Table table = new Table(gRuleSelGroup, SWT.CHECK);</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		fRules = CheckboxTableViewer.newCheckList(gRuleSelGroup, SWT.BORDER);
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		<em class="jxr_comment">// fRules = new CheckboxTableViewer(table);</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		GridData data2 = <strong class="jxr_keyword">new</strong> GridData(GridData.FILL_BOTH);
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		data2.heightHint = 200;
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 		<em class="jxr_comment">// data.widthHint = 200;</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		fRules.getTable().setLayoutData(data);
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		fRules.setLabelProvider(<strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/RuleLabelProvider.html">RuleLabelProvider</a>());
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		fRules.setContentProvider(<strong class="jxr_keyword">new</strong> ArrayContentProvider());
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		fRules.setInput(globalRuleList.toArray());
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		<strong class="jxr_keyword">for</strong> (ContainerRule rule : globalRuleList) {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			<strong class="jxr_keyword">if</strong> (isRuleApplied(rule)) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 				fRules.setChecked(rule, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		}
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		fRules.addSelectionChangedListener(<strong class="jxr_keyword">new</strong> ISelectionChangedListener() {
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 			@Override
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> selectionChanged(SelectionChangedEvent event) {
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 				ISelection selection = fRules.getSelection();
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 				<strong class="jxr_keyword">if</strong> (selection instanceof StructuredSelection) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 					Object[] selected = ((StructuredSelection) selection).toArray();
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 					<strong class="jxr_keyword">if</strong> ((selected.length == 1) &amp;&amp; (selected[0] instanceof ContainerRule)) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 						<strong class="jxr_keyword">if</strong> (m_currentRule != selected[0]) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 							selectRule((ContainerRule) selected[0]);
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 						}
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 					}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 				}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			}
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		});
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		fRules.addCheckStateListener(checkListener);
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createRuleInfoGroup(Composite parent) {
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		GridData groupGridData = DialogUtils.createFillGridData();
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		<em class="jxr_comment">// data3.widthHint = 400;</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		<em class="jxr_comment">// data3.heightHint = 300;</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		Group ruleInfoGroup = <strong class="jxr_keyword">new</strong> Group(parent, SWT.BORDER);
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		ruleInfoGroup.setText(<span class="jxr_string">" rule information "</span>);
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		<em class="jxr_comment">// ruleGroup.setLayout(new RowLayout (SWT.VERTICAL));</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		ruleInfoGroup.setLayout(<strong class="jxr_keyword">new</strong> GridLayout(2, false));
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		ruleInfoGroup.setLayoutData(groupGridData);
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		GridData span2 = <strong class="jxr_keyword">new</strong> GridData();
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 		span2.horizontalSpan = 2;
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 		span2.horizontalAlignment = GridData.FILL;
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		span2.grabExcessHorizontalSpace = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		span2.grabExcessVerticalSpace = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		span2.verticalAlignment = GridData.FILL;
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 		span2.heightHint = 80;
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 		fDescription = <strong class="jxr_keyword">new</strong> Text(ruleInfoGroup, SWT.WRAP | SWT.V_SCROLL | SWT.READ_ONLY);
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 		fDescription.setLayoutData(span2);
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		<em class="jxr_comment">// createMessageArea (ruleInfoGroup);</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		ruleInfoGroup.pack();
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 		<em class="jxr_comment">// fPortLabel = new Label (ruleInfoGroup, SWT.NONE);</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 		<em class="jxr_comment">// fPortLabel.setText ("for Ports");</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 		<em class="jxr_comment">// fPortLabel.setEnabled (false);</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 	}
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> <em class="jxr_javadoccomment">	 * Select a rule, i.e. update the visual representation from the rule</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L234" href="#L234">234</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> selectRule(ContainerRule rule) {
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		m_currentRule = rule;
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		fDescription.setText(DescriptionUtils.getDescription(rule.getBase_Class()));
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	}
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> <em class="jxr_javadoccomment">	 * Helper: add a local container rule to the current class</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 *            the name of the local rule</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 	ContainerRule addRule(String name) {
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		Class ruleCl = (Class)
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 				m_component.createNestedClassifier(name, UMLPackage.eINSTANCE.getClass_());
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		StereotypeUtil.apply(ruleCl, ContainerRule.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 		<strong class="jxr_keyword">return</strong> UMLUtil.getStereotypeApplication(ruleCl, ContainerRule.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 	}
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L256" href="#L256">256</a> <em class="jxr_javadoccomment">	 * Helper function: delete a container rule from a class</em>
<a class="jxr_linenumber" name="L257" href="#L257">257</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L259" href="#L259">259</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 	<strong class="jxr_keyword">void</strong> deleteRule(ContainerRule rule) {
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 		Classifier ruleCl = m_component.getNestedClassifier(rule.getBase_Class().getName());
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 		<strong class="jxr_keyword">if</strong> (ruleCl instanceof Class) {
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 			ruleCl.destroy();
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 		}
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 	}
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L268" href="#L268">268</a> <em class="jxr_javadoccomment">	 * Helper: apply a container rule to current component</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L270" href="#L270">270</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L271" href="#L271">271</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 	<strong class="jxr_keyword">void</strong> applyRule(ContainerRule rule) {
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 		<strong class="jxr_keyword">if</strong> (!StereotypeUtil.isApplied(m_component, RuleApplication.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 			StereotypeUtil.apply(m_component, RuleApplication.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 		}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 		RuleApplication containerConfig =
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 				UMLUtil.getStereotypeApplication(m_component, RuleApplication.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 		containerConfig.getContainerRule().add(rule);
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 	}
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L282" href="#L282">282</a> <em class="jxr_javadoccomment">	 * Helper: apply a container rule to current component</em>
<a class="jxr_linenumber" name="L283" href="#L283">283</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L285" href="#L285">285</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 	<strong class="jxr_keyword">void</strong> unapplyRule(ContainerRule rule) {
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		RuleApplication containerConfig =
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 				UMLUtil.getStereotypeApplication(m_component, RuleApplication.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 		<strong class="jxr_keyword">int</strong> index = containerConfig.getContainerRule().indexOf(rule);
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 		<strong class="jxr_keyword">if</strong> ((index &gt;= 0) &amp;&amp; (index &lt; containerConfig.getContainerRule().size())) {
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 			containerConfig.getContainerRule().remove(index);
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 		}
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 	}
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L296" href="#L296">296</a> <em class="jxr_javadoccomment">	 * check whether a container rule is applied</em>
<a class="jxr_linenumber" name="L297" href="#L297">297</a> <em class="jxr_javadoccomment">	 * h * @param rule</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> <em class="jxr_javadoccomment">	 * @return true, if container rule is applied</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 	<strong class="jxr_keyword">boolean</strong> isRuleApplied(ContainerRule rule) {
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 		RuleApplication containerConfig =
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 				UMLUtil.getStereotypeApplication(m_component, RuleApplication.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 		<strong class="jxr_keyword">if</strong> (containerConfig != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 			<strong class="jxr_keyword">return</strong> containerConfig.getContainerRule().contains(rule);
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 		}
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 	}
<a class="jxr_linenumber" name="L309" href="#L309">309</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
